import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Tahvel3 extends Applet 
  implements MouseListener, MouseMotionListener, JooniseKuular, ActionListener{
  /**
  *  Kujundi alguse x (hiir alla)
  */
  int hax;
  /**
  *  Kujundi alguse y
  */
  int hay;
  /**
  * Kujundi lpu x
  */
  int hyx;
  /**
  * Kujundi lpu y
  */
  int hyy;
  /**
  * Joonistatavate kujundite loetelu.
  */
  String[] kujundid={"Joon", "Ristklik", "Ovaal", "Vabakejoon"};
  /**
  * Valikukombo.
  */
  Choice kujundivalik=new Choice();
  /**
  * Kujunditeadete pdja. Vib olla nii tahvel ise, teine
  * tahvel, GrKlient kui mni muu JooniseKuularit realiseeriva
  * klassi eksemplar.
  */
  JooniseKuular kuulaja=null;
  /**
  * Joonistamiseks meeles peetavad kujundid
  */
  LinkedList hoidla=new LinkedList();
  /**
  * Hoidla thjendus, pildi puhastus.
  */
  Button tyhjenda=new Button("Thjenda");

  /**
  * Initsialiseerimine
  */
  public Tahvel3(){
    addMouseListener(this);
    addMouseMotionListener(this);
    for(int i=0; i<kujundid.length; i++){
      kujundivalik.addItem(kujundid[i]);
    }
    add(kujundivalik);
    add(tyhjenda);
    tyhjenda.addActionListener(this);
  }
  
  /**
  * Kujundite kuulaja lisamine. Korraga suudab teateid
  * saata vaid hele kuulajale.
  */
  public void lisaJooniseKuular(JooniseKuular j){
    kuulaja=j;
  }
  
  /**
  * Joonis hoidla phjal.
  */
  public void paint(Graphics g){     
     for(Iterator it=hoidla.iterator(); it.hasNext();){
       String s=(String)it.next();
       joonista(s);
     }
  }
  
  /**
  * he saabunud kujundi lahkamine snest ja joonistus.
  */
  void joonista(String andmed){
   try{
    Graphics g=getGraphics();
    StringTokenizer stk=new StringTokenizer(andmed);
    String tyyp=stk.nextToken();
    int a[]=new int[4];
    for(int i=0; i<4; i++){
       a[i]=Integer.parseInt(stk.nextToken());
    }
    if(tyyp.equals(".pj")){
      g.drawLine(a[0], a[1], a[2], a[3]);
    }
    if(tyyp.equals(".pr")){
      g.drawRect(a[0], a[1], a[2], a[3]);
    }
    if(tyyp.equals(".po")){
      g.drawOval(a[0], a[1], a[2], a[3]);
    }
   }catch(Exception viga){viga.printStackTrace();}
  }
  
  /**
  * Saabuv kujund
  */
  public void kujund(String andmed){
    joonista(andmed);
    hoidla.add(andmed);
  }  
  
  /**
  * Salvestatakse hiire allavajutuse koordinaadid.
  */
  public void mousePressed(MouseEvent e){
    hax=e.getX();
    hay=e.getY();
  }
  
  /**
  * Salvestatakse hiire leslaskmise koordinaadid. Vajadusel
  * luuakse kujund.
  */
  public void mouseReleased(MouseEvent e){
    hyx=e.getX();
    hyy=e.getY();  
    saada();
  }
  
  /**
  * Thjendusnupule reageerimine.
  */
  public void actionPerformed(ActionEvent e){
    if(e.getSource()==tyhjenda){
      hoidla.clear();
      repaint();
    }
  }
  
  /**
  * Lohistamine. Vhemasti vabakejoone tarbeks.
  */
  public void mouseDragged(MouseEvent e)
  {
    if(kujundivalik.getSelectedItem().equals("Vabakejoon")){
        hyx = e.getX();
        hyy = e.getY();
        saada();
        hax = hyx;
        hay = hyy;
    }
  }
  
  /**
  * Thi meetod, vajalik liikumisliidese realiseerimiseks.
  */
  public void mouseMoved(MouseEvent e){}


  /**
  * Andmete vljastus jooniseKuulajale. Kuulaja puudumise
  * korral ei vljastata midagi. 
  */
  void saada(){
    if(kuulaja==null){return;}
    int laius=hyx-hax;
    int korgus=hyy-hay;
    if(kujundivalik.getSelectedItem().equals("Joon")||
       kujundivalik.getSelectedItem().equals("Vabakejoon")){
      kuulaja.kujund(".pj "+hax+" "+hay+" "+hyx+" "+hyy);
    }
    if(kujundivalik.getSelectedItem().equals("Ristklik")){
      kuulaja.kujund(".pr "+hax+" "+hay+" "+laius+" "+korgus);
    }
    if(kujundivalik.getSelectedItem().equals("Ovaal")){
      kuulaja.kujund(".po "+hax+" "+hay+" "+laius+" "+korgus);
    }
  }
  
  /**
  * Olemasolevate kujundite koopia.
  */  
  public LinkedList hoidlaKoopia(){
    return new LinkedList(hoidla);
  }
  
  /**
  * Uus hoidla sisu ja ekraanipilt.
  */
  public void hoidlaUusSisu(Collection c){
    hoidla.clear();
    hoidla.addAll(c);
    repaint();
  }
  
  /**
  * Thi meetod, vajalik hiireliidese realiseerimiseks.
  */
  public void mouseClicked(MouseEvent e){}
  /**
  * Thi meetod, vajalik hiireliidese realiseerimiseks.
  */
  public void mouseEntered(MouseEvent e){}
  /**
  * Thi meetod, vajalik hiireliidese realiseerimiseks.
  */
  public void mouseExited(MouseEvent e){}
  /**
  * Vimaldab tahvlit iseseisvalt joonistusluendina kivitada.
  * Joonistab iseendale.
  */
  public static void main(String[] argumendid){
    Frame f=new Frame();
    Tahvel3 t=new Tahvel3();
    t.lisaJooniseKuular(t);
    f.add(t);
    f.setSize(300, 300);
    f.setVisible(true);
  }
}
